SystemOrganization addCategory: #'TADP-TP1'!
SystemOrganization addCategory: #'TADP-TP1-Tests'!

Trait named: #Actividad
	uses: {}
	category: 'TADP-TP1'!

!Actividad methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 12:39'!
esArticulo 
self requirement! !

!Actividad methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 12:33'!
estadoDeAprobacion 
self requirement! !

!Actividad methodsFor: 'as yet unclassified' stamp: 'chacho 9/14/2013 02:36'!
nombre
self requirement! !

!Actividad methodsFor: 'as yet unclassified' stamp: 'chacho 9/13/2013 16:47'!
pendienteDeAprobacion 
^self estadoDeAprobacion not! !

Trait named: #Estadistica
	uses: {}
	category: 'TADP-TP1'!

!Estadistica methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/16/2013 13:15'!
cantidadAbandonadas
^(self  selectAbandonadas: self getMaterias ) size 

! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/16/2013 13:14'!
cantidadAprobadas
^( self  selectAprobadas: self getMaterias ) size

! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/16/2013 13:16'!
cantidadAprobadasSobreCursadas

^((self  selectAprobadas:self getMaterias ) size )/ ((self selectCursadas: self getMaterias) size)

! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/16/2013 13:16'!
cantidadDesaprobadas
^(self selectCantidadDesaprobadas: self getMaterias  )

! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/6/2013 09:53'!
getMaterias
	self requirement! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/16/2013 13:17'!
getMateriasAprobadas 
	^(self selectAprobadas: self getMaterias) .! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/16/2013 13:18'!
listadoDeNotas
|col materias | 
col := Array  new:10.

materias := ((self selectTerminada: self getMaterias) collect: [:mat | mat nota]).


col at: 1 put: (materias occurrencesOf: 1).
col at:2 put: (materias occurrencesOf: 2).
col at:3 put:(materias occurrencesOf: 3).
col at:4 put:(materias occurrencesOf: 4).
col at:5 put:(materias occurrencesOf: 5).
col at:6 put:(materias occurrencesOf: 6).
col at:7 put:(materias occurrencesOf: 7).
col at:8 put: (materias occurrencesOf: 8).
col at:9 put:(materias occurrencesOf: 9).
col at:10 put:(materias occurrencesOf: 10).


^col! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 16:08'!
notaMasAlta: nVeces

|index listaInversa acum|
listaInversa := (self listadoDeNotas) reverse.
acum := nVeces.
index := 10.
listaInversa do: [:nota | nota >= acum ifTrue: [^index ] ifFalse:[acum := acum - nota. index := index -1] ].

"(11 - (listaInversa indexOf: nota))"! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/9/2013 14:57'!
promedioConAplazos
|sumatoria|
sumatoria:= 0.
self getMaterias do: [:materia | sumatoria := sumatoria + materia nota ].

^(sumatoria / (self getMaterias size)).! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/16/2013 13:18'!
promedioSinAplazos
|sumatoria|
sumatoria:= 0.
(self selectAprobadas: self getMaterias ) do: [:materiaAprobada | sumatoria := sumatoria + materiaAprobada  nota ].
^(sumatoria / (self getMaterias ;cantidadAprobadas) ).! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/16/2013 13:15'!
selectAbandonadas: materias
^(materias select: [:materia | materia abandonada] )! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/16/2013 13:14'!
selectAprobadas: materias
^(materias select: [:materia | materia aprobada])! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/16/2013 13:15'!
selectCursadas: materias
^(materias  select: [:materia | materia cursada])! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/16/2013 13:16'!
selectTerminada: materias
^(materias  select: [ :materia | materia terminada])! !

Trait named: #EstadisticaAnual
	uses: Estadistica
	category: 'TADP-TP1'!

EstadisticaAnual classTrait
	uses: Estadistica classTrait!

!EstadisticaAnual methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/16/2013 13:29'!
cantidadAbandonadas:unAnio
^(self selectAbandonadas: (self selectUnAnio: unAnio  materias: self getMaterias)  ) size 

! !

!EstadisticaAnual methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/16/2013 13:30'!
cantidadAprobadas: unAnio 
^(self selectAprobadas: (self selectUnAnio: unAnio  materias: self getMaterias)   ) size
! !

!EstadisticaAnual methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/16/2013 13:31'!
cantidadAprobadasSobreCursadas:unAnio

^((self  selectAprobadas: (self selectUnAnio: unAnio  materias: self getMaterias) ) size )/ ((self selectCursadas:(self selectUnAnio: unAnio  materias: self getMaterias) ) size)
! !

!EstadisticaAnual methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/16/2013 13:32'!
listadoDeNotas:unAnio
|col materias | 
col := Array  new:10.

materias := ((self  selectTerminada:  (self selectUnAnio: unAnio  materias: self getMaterias) ) collect: [:mat | mat nota]).


col at: 1 put: (materias occurrencesOf: 1).
col at:2 put: (materias occurrencesOf: 2).
col at:3 put:(materias occurrencesOf: 3).
col at:4 put:(materias occurrencesOf: 4).
col at:5 put:(materias occurrencesOf: 5).
col at:6 put:(materias occurrencesOf: 6).
col at:7 put:(materias occurrencesOf: 7).
col at:8 put: (materias occurrencesOf: 8).
col at:9 put:(materias occurrencesOf: 9).
col at:10 put:(materias occurrencesOf: 10).


^col! !

!EstadisticaAnual methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/13/2013 16:33'!
notaMasAlta: nVeces yAnio:unAnio

|index listaInversa acum|
listaInversa := (self listadoDeNotas:unAnio) reverse.
acum := nVeces.
index := 10.
listaInversa do: [:nota | nota >= acum ifTrue: [^index ] ifFalse:[acum := acum - nota. index := index -1] ].

"(11 - (listaInversa indexOf: nota))"! !

!EstadisticaAnual methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/16/2013 13:33'!
promedioConAplazos:unAnio
|sumatoria col|
sumatoria:= 0.
col :=  self selectUnAnio: unAnio  materias: self getMaterias.
col do: [:materia | sumatoria := sumatoria + materia nota ].

^(sumatoria / (col size)).! !

!EstadisticaAnual methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/16/2013 13:33'!
promedioSinAplazos:unAnio
|sumatoria col|
sumatoria:= 0.
col :=  (self selectUnAnio: unAnio  materias: self getMaterias) .
( self selectAprobadas: col ) do: [:materiaAprobada | sumatoria := sumatoria + materiaAprobada  nota ].
^(sumatoria / (self cantidadAprobadas:unAnio ) ).! !

!EstadisticaAnual methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/16/2013 13:21'!
selectUnAnio: unAnio materias: materias
^(materias select: [:materia |materia curso anio = unAnio] )! !

Trait named: #Home
	uses: {}
	category: 'TADP-TP1'!

!Home classSide methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 21:27'!
newConHome: unHome
	^self new
		home: unHome;
		yourself.! !

Trait named: #Investigador
	uses: {}
	category: 'TADP-TP1'!

!Investigador methodsFor: 'as yet unclassified' stamp: 'chacho 9/14/2013 05:55'!
listadoDeEventos
^self gruposDeInvestigacion gather:  [:unGrupo | unGrupo listarEventos].! !

TestCase subclass: #TP1Tests
	instanceVariableNames: 'estudiante carrera alumnoPerez cursoHistoria home historia profesorGarcia grupo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1-Tests'!

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'chacho 9/14/2013 03:16'!
setUp 
	home:= HomeMaterias new.
	alumnoPerez := Alumno newConHome: home .
	historia := Materia newConHome: home .
	profesorGarcia:= Docente new.
	cursoHistoria := Curso  newConHome: home .
	carrera := Carrera new.
	grupo := Grupo new.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 12:57'!
testAlumnoCantidadAbandonadas
	|alumnoRodriguez|
	alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso  newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada  newConCurso: cursoHistoria  yNota: 1  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso   newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso   newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada  newConCurso: cursoHistoria  yNota: 0  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada  newConCurso: cursoHistoria  yNota: 0 yAlumno: alumnoPerez yMateria: historia ).
	self assert: alumnoPerez cantidadAbandonadas equals: 2.
	self assert: alumnoRodriguez  cantidadAbandonadas equals: 1.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/13/2013 17:17'!
testAlumnoCantidadAbandonadasAnio
	|alumnoRodriguez cursoAlgebra|
	alumnoRodriguez := Alumno newConHome:  home .
	cursoAlgebra := Curso newConHome: home.
	cursoAlgebra anio: 2013.
	cursoHistoria anio: 2012.
	
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoAlgebra  yNota: 4  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso  newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada  newConCurso: cursoHistoria  yNota: 1  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso   newConCurso: cursoAlgebra  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso   newConCurso: cursoAlgebra  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada  newConCurso: cursoAlgebra  yNota: 0  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada  newConCurso: cursoAlgebra  yNota: 0 yAlumno: alumnoPerez yMateria: historia ).

	self assert: (alumnoPerez cantidadAbandonadas:2013) equals: 2.
	self assert: (alumnoRodriguez cantidadAbandonadas: 2012) equals: 1.
! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 13:05'!
testAlumnoCantidadAprobadas
	|alumnoRodriguez|
	alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso  newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada  newConCurso: cursoHistoria  yNota: 1  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 6  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso   newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso   newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada  newConCurso: cursoHistoria  yNota: 0  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada  newConCurso: cursoHistoria  yNota: 0 yAlumno: alumnoPerez yMateria: historia ).
	self assert: alumnoPerez cantidadAprobadasSobreCursadas  equals: (3/5).
	self assert: alumnoRodriguez  cantidadAprobadasSobreCursadas   equals: (1/2).! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/13/2013 17:22'!
testAlumnoCantidadAprobadasAnio
	|alumnoRodriguez cursoAlgebra|
	alumnoRodriguez := Alumno newConHome:  home .
	cursoAlgebra := Curso newConHome: home.
	cursoAlgebra anio: 2013.
	cursoHistoria anio: 2012.

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso  newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada  newConCurso: cursoHistoria  yNota: 1  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoAlgebra  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoAlgebra  yNota: 6  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoAlgebra  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso   newConCurso: cursoAlgebra  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso   newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada  newConCurso: cursoAlgebra  yNota: 0  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada  newConCurso: cursoHistoria  yNota: 0 yAlumno: alumnoPerez yMateria: historia ).
	
	self assert: (alumnoRodriguez  cantidadAprobadasSobreCursadas:2012)   equals: (1/2).
	self assert: (alumnoPerez cantidadAprobadasSobreCursadas: 2013)  equals: (3/4).! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'chacho 9/14/2013 06:03'!
testAlumnoDocenteListadoDeEventos
|grupo2 proyecto seminario charla sesion1 sesion2 resultado1 resultado2|
grupo2 := Grupo new.

proyecto := Proyecto new.
proyecto estadoDeAprobacion: true.
proyecto costo: 500.
proyecto nombre: 'proyecto'.

seminario := Seminario new.
seminario estadoDeAprobacion: true.
seminario costo: 400.
seminario nombre: 'seminario'.

charla := Charla new.
charla estadoDeAprobacion: true.
charla costo: 500.
charla nombre: 'charla'.
charla horaDesde: 9.
charla horaHasta: 10.
charla fecha: '10/12/2013'.
charla detalle: 'transporte'.

sesion1 := Sesion new.
sesion1 fecha: '12/12/2013'.
sesion1 horaDesde: 10.
sesion1 horaHasta: 11.
sesion1 detalle: 'introduccion'.

sesion2 := Sesion new.
sesion2  fecha: '13/12/2013'.
sesion2  horaDesde: 10.
sesion2  horaHasta: 11.
sesion2  detalle: 'desarrollo'.

resultado1 := Resultado new.
resultado1 detalle: 'nada'.
resultado1 nombre: 'termodinamica'.
resultado1 sesion: sesion1.

resultado2 := Resultado new.
resultado2 detalle: 'articulito'.
resultado2 nombre: 'electricidad'.
resultado2 sesion: sesion2.

seminario addSesion: sesion1.
seminario addSesion: sesion2.

proyecto addResultado: resultado1.
proyecto addResultado: resultado2.

grupo  addActividad: charla.
grupo addActividad: seminario.
grupo2 addActividad: proyecto.

alumnoPerez  addGrupoDeInvestigacion: grupo.
alumnoPerez addGrupoDeInvestigacion: grupo2.
profesorGarcia addGrupoDeInvestigacion: grupo2.
	
	self assert: alumnoPerez listadoDeEventos size equals: 5.
	self assert: profesorGarcia listadoDeEventos size equals: 2.
	! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 12:58'!
testAlumnoListado
|col|
col := Array new: 10.

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	
col at: 1 put: 0.
col at: 2 put: 2.
col at: 3 put: 0.
col at: 4 put: 0.
col at: 5 put: 0.
col at: 6 put: 0.
col at: 7 put: 0.
col at: 8 put: 2.
col at: 9 put: 0.
col at: 10 put: 0.
	self assert: alumnoPerez listadoDeNotas  equals: col .! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/13/2013 17:25'!
testAlumnoListadoAnio
|col cursoAlgebra|
col := Array new: 10.

	cursoAlgebra := Curso newConHome: home.
	cursoAlgebra anio: 2013.
	cursoHistoria anio: 2012.

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoAlgebra  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoAlgebra  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	
col at: 1 put: 0.
col at: 2 put: 1.
col at: 3 put: 0.
col at: 4 put: 0.
col at: 5 put: 0.
col at: 6 put: 0.
col at: 7 put: 0.
col at: 8 put: 1.
col at: 9 put: 0.
col at: 10 put: 0.
	self assert: (alumnoPerez listadoDeNotas:2013) equals: col .! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 16:03'!
testAlumnoNotaMasAltaNVeces
|resultado1 resultado2 resultado3|
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	resultado1  := alumnoPerez notaMasAlta: 4.
 	resultado2 := alumnoPerez notaMasAlta: 6.
	resultado3 := alumnoPerez notaMasAlta: 8.
	self assert: 10 equals: resultado1.		
	self assert: 8 equals: resultado2.
	self assert: 2 equals: resultado3.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/13/2013 17:30'!
testAlumnoNotaMasAltaNVecesAnio
|resultado1 resultado2 resultado3 cursoAlgebra|

	cursoAlgebra := Curso newConHome: home.
	cursoAlgebra anio: 2013.
	cursoHistoria anio: 2012.
	
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoAlgebra  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoAlgebra  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoAlgebra  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoAlgebra  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	
	resultado1  := alumnoPerez notaMasAlta: 4 yAnio: 2012.
 	resultado2 := alumnoPerez notaMasAlta: 6 yAnio: 2012.
	resultado3 := alumnoPerez notaMasAlta: 8 yAnio: 2012.
	self assert: 10 equals: resultado1.		
	self assert: 8 equals: resultado2.
	self assert: 2 equals: resultado3.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 12:56'!
testAlumnoPromedioConAplazos

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
self assert: alumnoPerez promedioConAplazos equals: 4.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/13/2013 17:34'!
testAlumnoPromedioConAplazosAnio
|cursoAlgebra|
	cursoAlgebra := Curso newConHome: home.
	cursoAlgebra anio: 2013.
	cursoHistoria anio: 2012.

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoAlgebra  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoAlgebra  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoAlgebra  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
self assert: (alumnoPerez promedioConAplazos:2012) equals: 4.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/13/2013 17:34'!
testAlumnoPromedioSinAplazos

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
self assert: 8 equals: alumnoPerez promedioSinAplazos.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/13/2013 17:35'!
testAlumnoPromedioSinAplazosAnio
|cursoAlgebra|
	cursoAlgebra := Curso newConHome: home.
	cursoAlgebra anio: 2013.
	cursoHistoria anio: 2012.
	
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoAlgebra  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoAlgebra  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoAlgebra  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
self assert: 8 equals: (alumnoPerez promedioSinAplazos:2012).! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 13:20'!
testCarreraCantidadAbandonadas
|alumnoRodriguez|
alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
carrera addAlumno: alumnoRodriguez.

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
carrera addAlumno: alumnoPerez.

self assert: 2 equals: carrera cantidadAbandonadas.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 13:19'!
testCarreraCantidadAprobadas
|alumnoRodriguez|
alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
carrera addAlumno: alumnoRodriguez.

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
carrera addAlumno: alumnoPerez.

self assert: 4 equals: carrera cantidadAprobadas.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 18:55'!
testCarreraListado
|alumnoRodriguez col|
col := Array new: 10.

alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	carrera addAlumno: alumnoRodriguez.

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 6  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	carrera addAlumno: alumnoPerez.

	col at: 1 put: 0.	
	col at: 2 put: 1.
	col at: 3 put: 0.
	col at: 4 put: 1.
	col at: 5 put: 1.
	col at: 6 put: 1.
	col at: 7 put: 0.
	col at: 8 put: 2.
	col at: 9 put: 0.
	col at: 10 put: 0.
	self assert: carrera listadoDeNotas equals: col .! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 16:16'!
testCarreraNotaMasAltaNVeces
|resultado1 resultado2 resultado3 resultado4 alumnoRodriguez|
	alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	carrera addAlumno: alumnoRodriguez.
	
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 7  yAlumno: alumnoPerez yMateria: historia ).
	carrera addAlumno: alumnoPerez.
	
	resultado1 := carrera notaMasAlta: 2.
 	resultado2 := carrera notaMasAlta: 4.
	resultado3 := carrera notaMasAlta: 6.
	resultado4 := carrera notaMasAlta: 7.
	self assert: 10 equals: resultado1.		
	self assert: 8 equals: resultado2.
	self assert: 7 equals: resultado3.
	self assert: 2 equals: resultado4.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 13:16'!
testCarreraPromedioConAplazos
|alumnoRodriguez|
alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
carrera addAlumno: alumnoRodriguez.

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia )..
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
carrera addAlumno: alumnoPerez.

self assert: 5 equals: carrera promedioConAplazos.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 13:01'!
testCarreraPromedioSinAplazos
|alumnoRodriguez|
alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 1  yAlumno: alumnoRodriguez  yMateria: historia ).
carrera addAlumno: alumnoRodriguez.

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 7  yAlumno: alumnoPerez yMateria: historia )..
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 9  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 1  yAlumno: alumnoPerez yMateria: historia ).
carrera addAlumno: alumnoPerez.

self assert: 6 equals: carrera promedioSinAplazos.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 18:53'!
testCursoCantidadAbandonadas
|alumnoRodriguez|
alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).

	self assert: 2 equals: cursoHistoria cantidadAbandonadas.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 18:54'!
testCursoCantidadAprobadas
|alumnoRodriguez|
alumnoRodriguez := Alumno newConHome:  home.
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).

	self assert: 4 equals: cursoHistoria cantidadAprobadas.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 18:55'!
testCursoListado
|alumnoRodriguez col|
col := Array new: 10.

alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 6  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).

	col at: 1 put: 0.	
	col at: 2 put: 1.
	col at: 3 put: 0.
	col at: 4 put: 1.
	col at: 5 put: 1.
	col at: 6 put: 1.
	col at: 7 put: 0.
	col at: 8 put: 2.
	col at: 9 put: 0.
	col at: 10 put: 0.
	self assert: cursoHistoria listadoDeNotas equals: col .! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 18:57'!
testCursoNotaMasAltaNVeces
|resultado1 resultado2 resultado3 resultado4 alumnoRodriguez|
	alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 7  yAlumno: alumnoPerez yMateria: historia ).
	
	resultado1 := cursoHistoria notaMasAlta: 2.
 	resultado2 := cursoHistoria notaMasAlta: 4.
	resultado3 := cursoHistoria notaMasAlta: 6.
	resultado4 := cursoHistoria notaMasAlta: 7.
	self assert: 10 equals: resultado1.		
	self assert: 8 equals: resultado2.
	self assert: 7 equals: resultado3.
	self assert: 2 equals: resultado4.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 19:26'!
testCursoPromedioConAplazos
|alumnoRodriguez|
	
	alumnoRodriguez := Alumno newConHome:  home.
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia )..
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).

	self assert: 5 equals: cursoHistoria promedioConAplazos.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 18:51'!
testCursoPromedioSinAplazos
|alumnoRodriguez|
alumnoRodriguez := Alumno newConHome:  home.

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 1  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 7  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 9  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 1  yAlumno: alumnoPerez yMateria: historia ).

self assert: 6 equals: cursoHistoria promedioSinAplazos.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 19:23'!
testDocenteCantidadAbandonadas
|alumnoRodriguez cursoProba|

 	profesorGarcia addCurso: cursoHistoria.
	cursoProba := Curso newConHome: home.
	profesorGarcia addCurso: cursoProba.

	alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).


	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoProba  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoProba  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).

	self assert: 2 equals: profesorGarcia cantidadAbandonadas.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/13/2013 17:50'!
testDocenteCantidadAbandonadasAnio
|alumnoRodriguez cursoProba|
	cursoProba := Curso newConHome: home.
 	profesorGarcia addCurso: cursoHistoria.
	profesorGarcia addCurso: cursoProba.
	cursoHistoria anio: 2012.
	cursoProba anio: 2013.	

	alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).


	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoProba  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoProba  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).

	self assert: 1 equals: (profesorGarcia cantidadAbandonadas:2012).
	self assert: 1 equals: (profesorGarcia cantidadAbandonadas:2013).! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 20:26'!
testDocenteCantidadAprobadas
|alumnoRodriguez cursoProba|

 	profesorGarcia addCurso: cursoHistoria.
	cursoProba := Curso newConHome: home.
	profesorGarcia addCurso: cursoProba.
	
	alumnoRodriguez := Alumno newConHome:  home.
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoProba  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoProba  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).

	self assert: 4 equals: profesorGarcia cantidadAprobadas.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/13/2013 17:53'!
testDocenteCantidadAprobadasAnio
|alumnoRodriguez cursoProba|
	cursoProba := Curso newConHome: home.
 	profesorGarcia addCurso: cursoHistoria.
	profesorGarcia addCurso: cursoProba.
	cursoHistoria anio: 2012.
	cursoProba anio: 2013.	
	
	alumnoRodriguez := Alumno newConHome:  home.
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoProba  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoProba  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).

	self assert: 2 equals: (profesorGarcia cantidadAprobadas:2013) .
	self assert: 2 equals: (profesorGarcia cantidadAprobadas:2012) .! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 19:31'!
testDocenteListado
|alumnoRodriguez col cursoProba|
col := Array new: 10.

 	profesorGarcia addCurso: cursoHistoria.
	cursoProba := Curso newConHome: home.
	profesorGarcia addCurso: cursoProba.
	
alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 6  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 4  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoProba  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoProba  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).

	col at: 1 put: 0.	
	col at: 2 put: 1.
	col at: 3 put: 0.
	col at: 4 put: 1.
	col at: 5 put: 1.
	col at: 6 put: 1.
	col at: 7 put: 0.
	col at: 8 put: 2.
	col at: 9 put: 0.
	col at: 10 put: 0.
	self assert: profesorGarcia listadoDeNotas equals: col .! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/13/2013 17:55'!
testDocenteListadoAnio
|alumnoRodriguez col cursoProba|
col := Array new: 10.
	cursoProba := Curso newConHome: home.
 	profesorGarcia addCurso: cursoHistoria.
	profesorGarcia addCurso: cursoProba.
	cursoHistoria anio: 2012.
	cursoProba anio: 2013.	
	
alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 6  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 4  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoProba  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoProba  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).

	col at: 1 put: 0.	
	col at: 2 put: 0.
	col at: 3 put: 0.
	col at: 4 put: 1.
	col at: 5 put: 1.
	col at: 6 put: 1.
	col at: 7 put: 0.
	col at: 8 put: 0.
	col at: 9 put: 0.
	col at: 10 put: 0.
	self assert: (profesorGarcia listadoDeNotas:2013) equals: col .! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 19:34'!
testDocenteNotaMasAltaNVeces
|alumnoRodriguez cursoProba|

 	profesorGarcia addCurso: cursoHistoria.
	cursoProba := Curso newConHome: home.
	profesorGarcia addCurso: cursoProba.
	
	alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 7  yAlumno: alumnoPerez yMateria: historia ).
	
	self assert: 10 equals: (profesorGarcia notaMasAlta: 2).
	self assert: 8 equals: (profesorGarcia notaMasAlta: 4).
	self assert: 7 equals: (profesorGarcia notaMasAlta: 6).
	self assert: 2 equals: (profesorGarcia notaMasAlta: 7).! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/13/2013 17:57'!
testDocenteNotaMasAltaNVecesAnio
|alumnoRodriguez cursoProba|
	cursoProba := Curso newConHome: home.
 	profesorGarcia addCurso: cursoHistoria.
	profesorGarcia addCurso: cursoProba.
	cursoHistoria anio: 2012.
	cursoProba anio: 2013.	
	
	alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 7  yAlumno: alumnoPerez yMateria: historia ).
	
	self assert: 10 equals: (profesorGarcia notaMasAlta: 2 yAnio:2013).
	self assert: 8 equals: (profesorGarcia notaMasAlta: 3 yAnio:2013).
	self assert: 7 equals: (profesorGarcia notaMasAlta: 4 yAnio:2013).! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 19:27'!
testDocentePromedioConAplazos
|alumnoRodriguez cursoProba|

 	profesorGarcia addCurso: cursoHistoria.
	cursoProba := Curso newConHome: home.
	profesorGarcia addCurso: cursoProba.
	
	alumnoRodriguez := Alumno newConHome:  home.
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 5  yAlumno: alumnoPerez yMateria: historia )..
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).

	self assert: 5 equals: profesorGarcia promedioConAplazos.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/13/2013 17:59'!
testDocentePromedioConAplazosAnio
|alumnoRodriguez cursoProba|
	cursoProba := Curso newConHome: home.
 	profesorGarcia addCurso: cursoHistoria.
	profesorGarcia addCurso: cursoProba.
	cursoHistoria anio: 2012.
	cursoProba anio: 2013.	
	
	alumnoRodriguez := Alumno newConHome:  home.
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 5  yAlumno: alumnoPerez yMateria: historia )..
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).

	self assert: 4 equals: (profesorGarcia promedioConAplazos:2013).! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 19:29'!
testDocentePromedioSinAplazos
|alumnoRodriguez cursoProba|

 	profesorGarcia addCurso: cursoHistoria.
	cursoProba := Curso newConHome: home.
	profesorGarcia addCurso: cursoProba.
	
	alumnoRodriguez := Alumno newConHome:  home.

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 1  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 7  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 9  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 1  yAlumno: alumnoPerez yMateria: historia ).

self assert: 6 equals: profesorGarcia promedioSinAplazos.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/13/2013 18:03'!
testDocentePromedioSinAplazosAnio
|alumnoRodriguez cursoProba|
	cursoProba := Curso newConHome: home.
 	profesorGarcia addCurso: cursoHistoria.
	profesorGarcia addCurso: cursoProba.
	cursoHistoria anio: 2012.
	cursoProba anio: 2013.	
	
	alumnoRodriguez := Alumno newConHome:  home.
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 1  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 7  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 9  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoProba  yNota: 1  yAlumno: alumnoPerez yMateria: historia ).

self assert: 8 equals: (profesorGarcia promedioSinAplazos:2013).! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'chacho 9/14/2013 04:24'!
testGrupoActividadesPendientesMontoTotal
	|proyecto sesion1 sesion2 resultado1 resultado2 charla |
	
	grupo := Grupo new.
	
	proyecto := Proyecto  new .
	proyecto estadoDeAprobacion: true.
	proyecto costo: 950.
	
	charla := Charla new.
	charla costo: 500.
	charla estadoDeAprobacion: false.
	charla nombre: 'charlita'.
	charla fecha: '12/10/13'.
	charla horaDesde: 9.
	charla horaHasta: 10.
		
	sesion1 := Sesion new.
	sesion1 fecha:  '12/02/2014'. 
	sesion1 horaDesde: 9 .
	sesion1 horaHasta: 10.
	
	sesion2  := Sesion new.
	sesion2 fecha:  '12/02/2014'. 
	sesion2 horaDesde: 10 .
	sesion2 horaHasta: 11.
	
	resultado1 := Resultado new.
	resultado1 detalle: 'esto es un articulo'.
	resultado1 nombre: 'resultado1'.
	resultado1 sesion: sesion1 .
	
	resultado2 := Resultado new.
	resultado2 detalle: 'nada'.
	resultado2 nombre: 'resultado2'.	
	resultado2 sesion: sesion2 .	
	
	proyecto addResultado: resultado1.
	proyecto addResultado: resultado2.
		
	grupo addActividad: charla .
	grupo addActividad: proyecto .
	
	self assert: grupo actividadesPendientesDeAprobacion size equals: 1.
	self assert: grupo montoTotalDeFinanciamientoDeActividadesPendientesDeAprobacion equals: 500.
	! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'chacho 9/14/2013 06:38'!
testGrupoArticulosPublicadosConFecha
	|proyecto sesion1 sesion2 resultado1 resultado2 charla seminario |
	
alumnoPerez := Alumno new.

proyecto := Proyecto new.
proyecto estadoDeAprobacion: true.
proyecto costo: 500.
proyecto nombre: 'proyecto'.

seminario := Seminario new.
seminario estadoDeAprobacion: true.
seminario costo: 400.
seminario nombre: 'seminario'.

charla := Charla new.
charla estadoDeAprobacion: true.
charla costo: 500.
charla nombre: 'charla'.
charla horaDesde: 9.
charla horaHasta: 10.
charla fecha: '10/12/2013'.
charla detalle: 'transporte'.

sesion1 := Sesion new.
sesion1 fecha: '12/12/2013'.
sesion1 horaDesde: 10.
sesion1 horaHasta: 11.
sesion1 detalle: 'introduccion'.

sesion2 := Sesion new.
sesion2  fecha: '13/12/2013'.
sesion2  horaDesde: 10.
sesion2  horaHasta: 11.
sesion2  detalle: 'desarrollo'.

resultado1 := Resultado new.
resultado1 detalle: 'nada'.
resultado1 nombre: 'termodinamica'.
resultado1 sesion: sesion1.

resultado2 := Resultado new.
resultado2 detalle: 'articulo'.
resultado2 nombre: 'electricidad'.
resultado2 sesion: sesion2.

seminario addSesion: sesion1.
seminario addSesion: sesion2.

proyecto addResultado: resultado1.
proyecto addResultado: resultado2.

grupo addActividad: charla.
grupo addActividad: seminario.
grupo addActividad: proyecto.

alumnoPerez  addGrupoDeInvestigacion: grupo.

	self assert: grupo articulosPublicadosConFecha size equals: 1.
! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 20:25'!
testMateriaCantidadAbandonadas
|alumnoRodriguez cursoHistoria2|

	cursoHistoria2 := Curso newConHome: home.
	historia addCurso: cursoHistoria.
	historia addCurso: cursoHistoria2.
	
	alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria2  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria2  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).

	self assert: 2 equals: historia cantidadAbandonadas.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 20:27'!
testMateriaCantidadAprobadas
|alumnoRodriguez cursoHistoria2|

	cursoHistoria2 := Curso newConHome: home.
	historia addCurso: cursoHistoria.
	historia addCurso: cursoHistoria2.
	
	alumnoRodriguez := Alumno newConHome:  home.
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria2  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria2  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).

	self assert: 4 equals: historia cantidadAprobadas.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 20:29'!
testMateriaListado
|alumnoRodriguez col cursoHistoria2|
col := Array new: 10.

	cursoHistoria2 := Curso newConHome: home.
	historia addCurso: cursoHistoria.
	historia addCurso: cursoHistoria2.
	
alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 6  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 4  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaEnCurso newConCurso: cursoHistoria2  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaAbandonada newConCurso: cursoHistoria2  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).

	col at: 1 put: 0.	
	col at: 2 put: 1.
	col at: 3 put: 0.
	col at: 4 put: 1.
	col at: 5 put: 1.
	col at: 6 put: 1.
	col at: 7 put: 0.
	col at: 8 put: 2.
	col at: 9 put: 0.
	col at: 10 put: 0.
	self assert: historia listadoDeNotas equals: col .! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 20:30'!
testMateriaNotaMasAltaNVeces
|alumnoRodriguez cursoHistoria2|

	cursoHistoria2 := Curso newConHome: home.
	historia addCurso: cursoHistoria.
	historia addCurso: cursoHistoria2.
	
	alumnoRodriguez := Alumno newConHome:  home .
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).
	
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 8  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 10  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 7  yAlumno: alumnoPerez yMateria: historia ).
	
	self assert: 10 equals: (historia notaMasAlta: 2).
	self assert: 8 equals: (historia notaMasAlta: 4).
	self assert: 7 equals: (historia notaMasAlta: 6).
	self assert: 2 equals: (historia notaMasAlta: 7).! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 20:27'!
testMateriaPromedioConAplazos
|alumnoRodriguez cursoHistoria2|

	cursoHistoria2 := Curso newConHome: home.
	historia addCurso: cursoHistoria.
	historia addCurso: cursoHistoria2.
	
	alumnoRodriguez := Alumno newConHome:  home.
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 8  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 2  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 5  yAlumno: alumnoPerez yMateria: historia )..
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 5  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 2  yAlumno: alumnoPerez yMateria: historia ).

	self assert: 5 equals: historia promedioConAplazos.! !

!TP1Tests methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 20:28'!
testMateriaPromedioSinAplazos
|alumnoRodriguez cursoHistoria2|

	cursoHistoria2 := Curso newConHome: home.
	historia addCurso: cursoHistoria.
	historia addCurso: cursoHistoria2.
	
	alumnoRodriguez := Alumno newConHome:  home.

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoRodriguez  yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 4  yAlumno: alumnoRodriguez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria  yNota: 1  yAlumno: alumnoRodriguez  yMateria: historia ).

	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 7  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 9  yAlumno: alumnoPerez yMateria: historia ).
	home addMateriaCursada: (MateriaFirmada newConCurso: cursoHistoria2  yNota: 1  yAlumno: alumnoPerez yMateria: historia ).

self assert: 6 equals: historia promedioSinAplazos.! !

Object subclass: #Alumno
	uses: Estadistica + Home + Investigador + EstadisticaAnual
	instanceVariableNames: 'home gruposDeInvestigacion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

Alumno class
	uses: Estadistica classTrait + Home classTrait + Investigador classTrait + EstadisticaAnual classTrait
	instanceVariableNames: ''!

!Alumno methodsFor: 'as yet unclassified' stamp: 'chacho 9/13/2013 17:46'!
addGrupoDeInvestigacion: unGrupo
self gruposDeInvestigacion add: unGrupo .! !

!Alumno methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 21:24'!
getMaterias
	^(home getMateriasDeAlumno: self)! !

!Alumno methodsFor: 'as yet unclassified' stamp: 'chacho 9/13/2013 17:45'!
gruposDeInvestigacion
^ gruposDeInvestigacion ! !

!Alumno methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 21:24'!
home
^ home! !

!Alumno methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 21:02'!
home: unHome 
home:= unHome ! !

!Alumno methodsFor: 'as yet unclassified' stamp: 'chacho 9/13/2013 17:43'!
initialize 
gruposDeInvestigacion := Set new.! !

Object subclass: #Carrera
	uses: Estadistica
	instanceVariableNames: 'alumnos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

Carrera class
	uses: Estadistica classTrait
	instanceVariableNames: ''!

!Carrera methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 10:21'!
addAlumno: unAlumno 
	alumnos  add: unAlumno  ! !

!Carrera methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 10:20'!
alumnos 
^alumnos ! !

!Carrera methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/13/2013 16:26'!
getMaterias
|col|
col := BagMaterias  new.
(self alumnos do: [:alumno | col addAll: alumno getMaterias ]).
^col! !

!Carrera methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/10/2013 17:29'!
initialize
alumnos := Set new.! !

!Carrera methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/10/2013 18:07'!
viejoMaterias
	^(self alumnos collect: [:alumno | alumno getMaterias ])! !

Object subclass: #Charla
	uses: Actividad
	instanceVariableNames: 'estadoDeAprobacion costo nombre horaDesde horaHasta fecha detalle sesion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

Charla class
	uses: Actividad classTrait
	instanceVariableNames: ''!

!Charla methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 15:44'!
costo
^costo! !

!Charla methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 15:44'!
costo: cos
costo:= cos! !

!Charla methodsFor: 'accessing' stamp: 'chacho 9/14/2013 04:36'!
detalle
	^ detalle! !

!Charla methodsFor: 'accessing' stamp: 'chacho 9/14/2013 04:36'!
detalle: anObject
	detalle := anObject! !

!Charla methodsFor: 'as yet unclassified' stamp: 'chacho 9/14/2013 04:16'!
esArticulo 
! !

!Charla methodsFor: 'as yet unclassified' stamp: 'chacho 9/14/2013 06:11'!
esProyecto
^false! !

!Charla methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 12:35'!
estadoDeAprobacion 
^estadoDeAprobacion! !

!Charla methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 12:35'!
estadoDeAprobacion: est
estadoDeAprobacion:= est! !

!Charla methodsFor: 'accessing' stamp: 'chacho 9/14/2013 03:38'!
fecha
	^ fecha! !

!Charla methodsFor: 'accessing' stamp: 'chacho 9/14/2013 03:38'!
fecha: anObject
	fecha := anObject! !

!Charla methodsFor: 'accessing' stamp: 'chacho 9/14/2013 03:50'!
horaDesde
	^ horaDesde! !

!Charla methodsFor: 'accessing' stamp: 'chacho 9/14/2013 03:50'!
horaDesde: anObject
	horaDesde := anObject! !

!Charla methodsFor: 'accessing' stamp: 'chacho 9/14/2013 03:50'!
horaHasta
	^ horaHasta! !

!Charla methodsFor: 'accessing' stamp: 'chacho 9/14/2013 03:50'!
horaHasta: anObject
	horaHasta := anObject! !

!Charla methodsFor: 'as yet unclassified' stamp: 'chacho 9/14/2013 05:46'!
listarEventos 
|evento set|

set := Set new.

evento := Array  new: 5.

evento at: 1 put: self nombre.
evento at:2 put: self fecha.
evento at:3 put: self horaDesde .
evento at:4 put: self horaHasta .
evento at:5 put: self detalle .

set add: evento .
^ set 

! !

!Charla methodsFor: 'as yet unclassified' stamp: 'chacho 9/13/2013 17:48'!
nombre
^nombre .! !

!Charla methodsFor: 'as yet unclassified' stamp: 'chacho 9/13/2013 17:48'!
nombre: unNombre
nombre := unNombre ! !

Object subclass: #Curso
	uses: Estadistica + Home
	instanceVariableNames: 'anio cuatrimestre materia home'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

Curso class
	uses: Estadistica classTrait + Home classTrait
	instanceVariableNames: ''!

!Curso methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/13/2013 17:02'!
anio
^anio
! !

!Curso methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/13/2013 17:02'!
anio: unAnio
anio := unAnio! !

!Curso methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:46'!
getMaterias
	^(home getMateriasDeCurso: self)! !

!Curso methodsFor: 'as yet unclassified' stamp: 'chacho 9/10/2013 16:17'!
getMateriasAprobadas 
	^(self getMaterias) collect: [:unaMateria | unaMateria aprobada ].! !

!Curso methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 21:02'!
home
^home! !

!Curso methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 21:02'!
home: unHome 
home:= unHome ! !

Object subclass: #Docente
	uses: Estadistica + Investigador + EstadisticaAnual
	instanceVariableNames: 'cursos gruposDeInvestigacion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

Docente class
	uses: Estadistica classTrait + Investigador classTrait + EstadisticaAnual classTrait
	instanceVariableNames: ''!

!Docente methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 19:07'!
addCurso: unCurso 
	cursos add: unCurso   ! !

!Docente methodsFor: 'as yet unclassified' stamp: 'chacho 9/14/2013 04:26'!
addGrupoDeInvestigacion: unGrupo
self gruposDeInvestigacion add: unGrupo .! !

!Docente methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 19:16'!
cursos
^cursos! !

!Docente methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 19:16'!
cursos: listaCursos
cursos := listaCursos ! !

!Docente methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/13/2013 16:27'!
getMaterias
	|col|
	col := BagMaterias  new.
	(self cursos do: [:curso | col addAll: curso getMaterias ]).
	^col! !

!Docente methodsFor: 'as yet unclassified' stamp: 'chacho 9/14/2013 04:26'!
gruposDeInvestigacion
^ gruposDeInvestigacion ! !

!Docente methodsFor: 'as yet unclassified' stamp: 'chacho 9/14/2013 04:26'!
initialize 
	cursos := Set new.  
	gruposDeInvestigacion := Set new.! !

Object subclass: #Grupo
	instanceVariableNames: 'actividades'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

!Grupo methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 11:57'!
actividades
^actividades ! !

!Grupo methodsFor: 'as yet unclassified' stamp: 'chacho 9/13/2013 17:09'!
actividadesPendientesDeAprobacion
^self actividades select: [:unaActividad | unaActividad pendienteDeAprobacion ] ! !

!Grupo methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 12:06'!
addActividad: act
actividades add: act! !

!Grupo methodsFor: 'as yet unclassified' stamp: 'chacho 9/14/2013 06:25'!
articulosPublicados
^self proyectos gather:[:unProyecto | unProyecto susArticulos ].! !

!Grupo methodsFor: 'as yet unclassified' stamp: 'chacho 9/14/2013 06:27'!
articulosPublicadosConFecha
|  set |
set := Set new.
self articulosPublicados do:[:unArticulo | set add: ( unArticulo nombre,' ', unArticulo fecha ) ].
^set! !

!Grupo methodsFor: 'as yet unclassified' stamp: 'chacho 9/13/2013 16:36'!
initialize 
actividades  := Set new.
! !

!Grupo methodsFor: 'as yet unclassified' stamp: 'chacho 9/14/2013 05:44'!
listarEventos
^self actividades gather:[:unaActividad | unaActividad listarEventos ] .
! !

!Grupo methodsFor: 'as yet unclassified' stamp: 'chacho 9/13/2013 17:10'!
montoTotalDeFinanciamiento
 ^self actividades sum: [:unaActividad | unaActividad costo]! !

!Grupo methodsFor: 'as yet unclassified' stamp: 'chacho 9/13/2013 17:10'!
montoTotalDeFinanciamientoDeActividadesPendientesDeAprobacion
 ^self actividadesPendientesDeAprobacion sum: [:unaActividad | unaActividad costo]

"nombre de mtodo bien descriptivo"! !

!Grupo methodsFor: 'as yet unclassified' stamp: 'chacho 9/14/2013 06:10'!
proyectos
^ self actividades select:[:unaActividad | unaActividad esProyecto]! !

Object subclass: #HomeMaterias
	instanceVariableNames: 'materiasCursadas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

!HomeMaterias methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:23'!
addMateriaCursada: unaMateria
materiasCursadas add: unaMateria ! !

!HomeMaterias methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:17'!
getMateriasDeAlumno: unAlumno
^(self materiasCursadas select: [:materia | materia  alumno  = unAlumno ])! !

!HomeMaterias methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:20'!
getMateriasDeCurso: unCurso
^(self materiasCursadas select: [:materia | materia curso  = unCurso])! !

!HomeMaterias methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:20'!
getMateriasDeMateria: unaMateria
^(self materiasCursadas select: [:materia | materia  materia  = unaMateria ])! !

!HomeMaterias methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/16/2013 13:19'!
initialize 
materiasCursadas := Bag new.
! !

!HomeMaterias methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/11/2013 09:44'!
materiasCursadas
^materiasCursadas! !

!HomeMaterias methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/11/2013 09:44'!
materiasCursadas: materia
materiasCursadas:= materia  ! !

Object subclass: #Materia
	uses: Estadistica + Home
	instanceVariableNames: 'home cursos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

Materia class
	uses: Estadistica classTrait + Home classTrait
	instanceVariableNames: ''!

!Materia methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 20:17'!
addCurso: unCurso 
	cursos add: unCurso   ! !

!Materia methodsFor: 'as yet unclassified' stamp: 'chacho 9/10/2013 16:38'!
addCursos: unCurso

self cursos add: unCurso.! !

!Materia methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 20:17'!
cursos
^cursos! !

!Materia methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 20:17'!
cursos: listaCursos
cursos := listaCursos ! !

!Materia methodsFor: 'as yet unclassified' stamp: 'chacho 9/10/2013 16:37'!
getCursos
^self cursos ! !

!Materia methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/13/2013 16:27'!
getMaterias
	|col|
	col := BagMaterias  new.
	(self cursos do: [:curso | col addAll: curso getMaterias ]).
	^col! !

!Materia methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 21:02'!
home
^home! !

!Materia methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 21:02'!
home: unHome 
home:= unHome ! !

!Materia methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 20:18'!
initialize
cursos := Set new.! !

Object subclass: #MateriaAbstracta
	instanceVariableNames: 'nota curso alumno materia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

MateriaAbstracta subclass: #MateriaAbandonada
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

!MateriaAbandonada methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 12:35'!
abandonada 
^true! !

!MateriaAbandonada methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:06'!
aprobada

^false! !

!MateriaAbandonada methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:06'!
cursada
 ^true! !

!MateriaAbandonada methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 13:34'!
terminada
^false! !

!MateriaAbstracta class methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:11'!
newConCurso: unCurso yNota: unaNota yAlumno: unAlumno  yMateria: unaMateria 
^self new
nota: unaNota;
curso: unCurso;
materia:  unaMateria ;
alumno: unAlumno ;
yourself.! !

!MateriaAbstracta methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 12:21'!
abandonada
^ self subclassResponsibility! !

!MateriaAbstracta methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:08'!
alumno
^alumno ! !

!MateriaAbstracta methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:09'!
alumno: unAlumno
alumno := unAlumno ! !

!MateriaAbstracta methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:08'!
curso
^curso ! !

!MateriaAbstracta methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:08'!
curso:unaNota
curso:=  unaNota ! !

!MateriaAbstracta methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:08'!
materia 
^materia ! !

!MateriaAbstracta methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:08'!
materia: unaMateria
materia := unaMateria ! !

!MateriaAbstracta methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:07'!
nota
^ nota! !

!MateriaAbstracta methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:07'!
nota:unaNota
nota:=  unaNota ! !

!MateriaAbstracta methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 13:34'!
terminada
^ self subclassResponsibility! !

MateriaAbstracta subclass: #MateriaEnCurso
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

!MateriaEnCurso methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 12:36'!
abandonada
^false! !

!MateriaEnCurso methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:07'!
aprobada 
^false! !

!MateriaEnCurso methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:07'!
cursada
^false! !

!MateriaEnCurso methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 13:34'!
terminada
^false! !

MateriaAbstracta subclass: #MateriaFirmada
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

!MateriaFirmada methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 12:36'!
abandonada
^false! !

!MateriaFirmada methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:09'!
aprobada
^nota>3! !

!MateriaFirmada methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/10/2013 20:10'!
cursada
^true! !

!MateriaFirmada methodsFor: 'as yet unclassified' stamp: 'Ramiro 9/11/2013 13:35'!
terminada
^true! !

Object subclass: #Proyecto
	uses: Actividad
	instanceVariableNames: 'estadoDeAprobacion resultado costo nombre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

Proyecto class
	uses: Actividad classTrait
	instanceVariableNames: ''!

!Proyecto methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 12:42'!
addResultado: res
resultado add: res! !

!Proyecto methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 15:44'!
costo 
^costo! !

!Proyecto methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 15:44'!
costo: cos
costo := cos! !

!Proyecto methodsFor: 'as yet unclassified' stamp: 'chacho 9/14/2013 06:11'!
esProyecto
^true! !

!Proyecto methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 12:20'!
estadoDeAprobacion 
^estadoDeAprobacion ! !

!Proyecto methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 12:20'!
estadoDeAprobacion: estado
estadoDeAprobacion:= estado  ! !

!Proyecto methodsFor: 'as yet unclassified' stamp: 'chacho 9/14/2013 03:42'!
initialize 
resultado := Set  new.
! !

!Proyecto methodsFor: 'as yet unclassified' stamp: 'chacho 9/14/2013 05:13'!
listarEventos
^self resultado collect: [:unExperimento | unExperimento listarEventos].! !

!Proyecto methodsFor: 'as yet unclassified' stamp: 'chacho 9/14/2013 02:40'!
nombre
^ self resultado do: [:unExperimento | unExperimento nombre ]! !

!Proyecto methodsFor: 'accessing' stamp: 'chacho 9/14/2013 05:07'!
nombre1
	^ nombre! !

!Proyecto methodsFor: 'accessing' stamp: 'chacho 9/14/2013 05:07'!
nombre: anObject
	nombre := anObject! !

!Proyecto methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 12:40'!
resultado 
^resultado ! !

!Proyecto methodsFor: 'as yet unclassified' stamp: 'chacho 9/14/2013 06:16'!
susArticulos
^self resultado select:[:unResultado | unResultado esArticulo ]! !

Object subclass: #Resultado
	instanceVariableNames: 'detalle sesion nombre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

!Resultado methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 16:21'!
detalle
^detalle! !

!Resultado methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 16:22'!
detalle:unDetalle
detalle := unDetalle ! !

!Resultado methodsFor: 'as yet unclassified' stamp: 'chacho 9/14/2013 06:37'!
esArticulo 
^self detalle includesSubString: 'articulo' .
""

"buscando lei que el metodo para buscar una subarray es includesSubString en esta pagina: http://en.wikipedia.org/wiki/Comparison_of_programming_languages_(string_functions)
pero no funca, o al menos en nuestra version de pharo :S ."
! !

!Resultado methodsFor: 'as yet unclassified' stamp: 'chacho 9/14/2013 03:58'!
fecha
^self sesion fecha .! !

!Resultado methodsFor: 'as yet unclassified' stamp: 'chacho 9/14/2013 05:09'!
listarEventos 
|evento|

evento := Array  new: 5.

evento at: 1 put: self nombre.
evento at:2 put: self fecha.
evento at:3 put: self sesion horaDesde  .
evento at:4 put: self sesion horaHasta .
evento at:5 put: self detalle .

^ evento! !

!Resultado methodsFor: 'as yet unclassified' stamp: 'chacho 9/14/2013 02:39'!
nombre 
^nombre ! !

!Resultado methodsFor: 'as yet unclassified' stamp: 'chacho 9/14/2013 02:39'!
nombre: unNombre
nombre := unNombre ! !

!Resultado methodsFor: 'as yet unclassified' stamp: 'chacho 9/14/2013 02:56'!
sesion
^sesion .! !

!Resultado methodsFor: 'as yet unclassified' stamp: 'chacho 9/14/2013 02:56'!
sesion: unaSesion 
sesion := unaSesion .! !

Object subclass: #Seminario
	uses: Actividad
	instanceVariableNames: 'estadoDeAprobacion costo nombre sesiones'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

Seminario class
	uses: Actividad classTrait
	instanceVariableNames: ''!

!Seminario methodsFor: 'as yet unclassified' stamp: 'chacho 9/14/2013 02:54'!
addSesion: unaSesion
self sesiones add: unaSesion ! !

!Seminario methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 15:42'!
costo
^costo! !

!Seminario methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 15:43'!
costo: cost
costo:= cost! !

!Seminario methodsFor: 'as yet unclassified' stamp: 'chacho 9/14/2013 04:16'!
esArticulo 
! !

!Seminario methodsFor: 'as yet unclassified' stamp: 'chacho 9/14/2013 06:11'!
esProyecto
^false! !

!Seminario methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 12:21'!
estadoDeAprobacion
^estadoDeAprobacion ! !

!Seminario methodsFor: 'as yet unclassified' stamp: 'MatasVallone 9/12/2013 12:21'!
estadoDeAprobacion: est
estadoDeAprobacion := est! !

!Seminario methodsFor: 'as yet unclassified' stamp: 'chacho 9/14/2013 02:53'!
initialize 
sesiones := Set new.! !

!Seminario methodsFor: 'as yet unclassified' stamp: 'chacho 9/14/2013 05:25'!
listarEventos
^self sesiones collect: [:unaSesion | unaSesion listarEventos: self nombre].! !

!Seminario methodsFor: 'as yet unclassified' stamp: 'chacho 9/14/2013 02:37'!
nombre
^nombre! !

!Seminario methodsFor: 'as yet unclassified' stamp: 'chacho 9/14/2013 02:37'!
nombre: unNombre 
nombre := unNombre .! !

!Seminario methodsFor: 'as yet unclassified' stamp: 'chacho 9/14/2013 02:54'!
sesiones
^sesiones! !

Object subclass: #Sesion
	instanceVariableNames: 'fecha horaDesde horaHasta detalle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-TP1'!

!Sesion methodsFor: 'accessing' stamp: 'chacho 9/14/2013 05:16'!
detalle
	^ detalle! !

!Sesion methodsFor: 'accessing' stamp: 'chacho 9/14/2013 05:16'!
detalle: anObject
	detalle := anObject! !

!Sesion methodsFor: 'accessing' stamp: 'chacho 9/14/2013 02:57'!
fecha
	^ fecha! !

!Sesion methodsFor: 'accessing' stamp: 'chacho 9/14/2013 02:57'!
fecha: anObject
	fecha := anObject! !

!Sesion methodsFor: 'accessing' stamp: 'chacho 9/14/2013 02:58'!
horaDesde
	^ horaDesde! !

!Sesion methodsFor: 'accessing' stamp: 'chacho 9/14/2013 02:58'!
horaDesde: anObject
	horaDesde := anObject! !

!Sesion methodsFor: 'accessing' stamp: 'chacho 9/14/2013 02:58'!
horaHasta
	^ horaHasta! !

!Sesion methodsFor: 'accessing' stamp: 'chacho 9/14/2013 02:58'!
horaHasta: anObject
	horaHasta := anObject! !

!Sesion methodsFor: 'accessing' stamp: 'chacho 9/14/2013 05:24'!
listarEventos 
|evento|

evento := Array  new: 5.

evento at: 1 put: self detalle.
evento at:2 put: self fecha.
evento at:3 put: self  horaDesde  .
evento at:4 put: self  horaHasta .
evento at:5 put: self detalle .

^ evento! !

!Sesion methodsFor: 'accessing' stamp: 'chacho 9/14/2013 05:25'!
listarEventos: nombreSeminario 
|evento|

evento := Array  new: 5.

evento at: 1 put: nombreSeminario.
evento at:2 put: self fecha.
evento at:3 put: self  horaDesde  .
evento at:4 put: self  horaHasta .
evento at:5 put: self detalle .

^ evento! !
